#include<project.h>
#include "EEPROM.h"
#include "I2CM_I2C.h"



uint8 value=0;

   
uint8 ReadExtEEPROM(void)
{

   
    uint8 ret=0;

   
   I2CM_I2CMasterClearStatus();

   I2CM_I2CMasterSendStart(MEMORY_TYPE_SLAVE_ADDRESS,0,0);
   
    
   I2CM_I2CMasterWriteByte(0X00,0);
   I2CM_I2CMasterWriteByte(0X00,0);
   I2CM_I2CMasterSendRestart(MEMORY_TYPE_SLAVE_ADDRESS,1,0);
   I2CM_I2CMasterReadByte(I2CM_I2C_NAK_DATA, &value,0);
   I2CM_I2CMasterSendStop(0);
   ret=value;
  return ret;

   
}
   
void WriteExtEEPROM(void)
{

   I2CM_I2CMasterSendStart(MEMORY_TYPE_SLAVE_ADDRESS,0,0);
 //CyDelay(10);
   I2CM_I2CMasterWriteByte(0X00,0);
 //CyDelay(10);
  I2CM_I2CMasterWriteByte(0X00,0);
   I2CM_I2CMasterWriteByte(0X40,0);
 //CyDelay(10);
   I2CM_I2CMasterSendStop(0);

  
}
uint8 Read_Eeprom(uint16 eeprom_addr)
{
            uint8 data=0;
            I2CM_I2CMasterClearStatus();/*Clear the I2c Mater status*/
            I2CM_I2CMasterSendStart(MEMORY_TYPE_SLAVE_ADDRESS,0,0);/*Start condition and slaveaddress with write option*/
            I2CM_I2CMasterWriteByte(eeprom_addr>>8,0);/*EEPROM Higher_byte Address*/
            I2CM_I2CMasterWriteByte((uint8)eeprom_addr,0);/*EEPROM Lower_byte Address*/
            I2CM_I2CMasterSendRestart(MEMORY_TYPE_SLAVE_ADDRESS,1,0);/*Start condition and slaveaddress with Read option*/
            I2CM_I2CMasterReadByte(I2CM_I2C_NAK_DATA, &data,0);/*No Ack*/
            I2CM_I2CMasterSendStop(0);/*Stop condition*/
            return data;   
}
   
void Write_Eeprom(uint16 eeprom_addr,uint8 data)
{
            I2CM_I2CMasterSendStart(MEMORY_TYPE_SLAVE_ADDRESS,0,0);/*Start condition and slaveaddress with write option*/
            I2CM_I2CMasterWriteByte(eeprom_addr>>8,0);/*EEPROM Higher_byte Address*/
            I2CM_I2CMasterWriteByte((uint8)eeprom_addr,0);/*EEPROM Lower_byte Address*/
            I2CM_I2CMasterWriteByte(data,0);/*Write Data*/
            I2CM_I2CMasterSendStop(0);/*stop Condition*/
}

void write_string(char *Data_Ptr)
{
            uint8 loop_count = 0,buffer_size = 0;
            buffer_size = strlen(Data_Ptr);
            Write_Eeprom(0x0000,buffer_size);
            CyDelay(10);
            for(loop_count = 1;loop_count<=buffer_size;loop_count++){
                Write_Eeprom(0x0000+loop_count,*Data_Ptr++);
                CyDelay(10);
            }
}

void  read_string(void)
{
            uint8 loop_count = 0,buffer_size = 0,buf_index = 0;
            memset(Read_buf,0,sizeof(Read_buf));
            buffer_size = Read_Eeprom(0x0000);
            CyDelay(10);
            for(loop_count = 1;loop_count<=buffer_size;loop_count++){
                Read_buf[buf_index++] = Read_Eeprom(0x0000+loop_count);
                CyDelay(10);
            }              
}